<?php

class AesRsaEncryptor
{
	private $aesKey;
	private $iv;
	private $publicKey;

	public function __construct($aesKey, $iv, $base64PublicKey)
	{
		$this->aesKey = $aesKey;
		$this->iv = $iv;
		$pemKey = '-----BEGIN PUBLIC KEY-----' . "\n" . chunk_split($base64PublicKey, 64, "\n") . '-----END PUBLIC KEY-----';
		$this->publicKey = openssl_pkey_get_public($pemKey);

		if (!$this->publicKey) {
			throw new Exception('Failed to load public key: ' . openssl_error_string());
		}
	}

	public function encrypt($data)
	{
		$chunkSize = 16;
		$dataChunks = str_split($data, $chunkSize);
		$encryptedChunks = [];

		foreach ($dataChunks as $index => $chunk) {
			$encryptedRsa = '';

			if (!openssl_public_encrypt($chunk, $encryptedRsa, $this->publicKey, OPENSSL_PKCS1_PADDING)) {
				throw new Exception('RSA encryption failed for chunk ' . ($index + 1));
			}

			$paddedData = base64_encode($encryptedRsa);
			$encryptedAes = openssl_encrypt($paddedData, 'AES-128-CBC', $this->aesKey, OPENSSL_RAW_DATA, $this->iv);

			if (!$encryptedAes) {
				throw new Exception('AES encryption failed for chunk ' . ($index + 1));
			}

			$encryptedChunks[] = base64_encode($encryptedAes);
		}

		return json_encode($encryptedChunks, JSON_PRETTY_PRINT);
	}
}

include __DIR__ . '/../includes/functions.php';
session_start();
$res = $db->select('dns', '*', '', '');
$rows = [];

foreach ($res as $row) {
	$rows[] = ['id' => (int) $row['id'], 'name' => $row['title'], 'url' => $row['url']];
}

header('Content-type: application/json; charset=UTF-8');
$final = json_encode(['portals' => $rows]);
$aesKey = 'wxPLgan2M8zD6TNw';
$iv = 'IGw2OPxW0IHmNIgI';
$pubkey = 'MIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQDPPAi/i9dx5F9iUC6EHHNGA5G4 ciYaCsgtxYGELMwHL4HglTPQ0Q5Q7nQ9iXquPhl1YYWqpFbhWKjTNMD0lQXwhb2g Pt10Areqc7By4W71n/mY+7x6WDx9e+EOVGonILeL/I3z1qQlDiMqhTiyjc5PzFbb HVHdicMBCcPgsRUOXwIDAQAB';
$encryptor = new AesRsaEncryptor($aesKey, $iv, $pubkey);
echo $encryptor->encrypt($final);
session_destroy();

?>